/* simple matrix multiply test app */
#include <stdio.h>
#include "multiply_d.h"

static inline unsigned long long int rdtsc( void )
{
  unsigned long long int retval;
  __asm __volatile ("rdtsc":"=A"(retval)::"memory");
  return retval;
}

int main(void) {
  int i,j;
  unsigned long long int start, stop;
  double a[DIM][DIM],
	 b[DIM][DIM],
	 c[DIM][DIM];

  /* Initialize A, B, and C matrices */
  for (i=0; i<NUM; i++)
    for (j=0; j<NUM; j++)
      a[i][j]= i+j;
  for (i=0; i<NUM; i++)
    for (j=0; j<NUM; j++)
      b[i][j]= i*j;
  for(i=0;i<NUM;i++)
    for(j=0;j<NUM;j++)
      c[i][j] = 0.0;

  /* Perform matrix multiply */
  start = rdtsc();
  multiply(a,b,c);
  stop = rdtsc();

  fprintf(stderr, "Cycles: %lld \n", stop-start);

  /* Okay, it's a trivial program */
  //printf("Here is the result matrix\n");
  for (i=0; i<NUM; i++) { 
    printf("\n"); 
    for (j=0; j<NUM; j++)
      printf("%6.2f  \t", c[i][j]);
  }
  printf ("\n");

  return 0;
}

